// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------

// GrayFilterDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "GrayFilter.h"
#include "GrayFilterDlg.h"
#include "LicenceDlg.h"
#include "ConfFileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGrayFilterDlg _CAO

CGrayFilterDlg::CGrayFilterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGrayFilterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGrayFilterDlg)
		// : ̈ʒu ClassWizard ɂăȍǉ܂B
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGrayFilterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGrayFilterDlg)
		// : ̏ꏊɂ ClassWizard ɂ DDX  DDV ̌Ăяoǉ܂B
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGrayFilterDlg, CDialog)
	//{{AFX_MSG_MAP(CGrayFilterDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_EXEREGION, OnExeregion)
	ON_BN_CLICKED(IDC_GRAB, OnGrab)
	ON_BN_CLICKED(IDC_LOADIMAGE, OnLoadimage)
	ON_BN_CLICKED(IDC_SAVEIMAGE, OnSaveimage)
	ON_BN_CLICKED(IDC_AVERAGING, OnAveraging)
	ON_BN_CLICKED(IDC_LAPLACIAN, OnLaplacian)
	ON_BN_CLICKED(IDC_MINFILTER, OnMinfilter)
	ON_BN_CLICKED(IDC_MAXFILTER, OnMaxfilter)
	ON_BN_CLICKED(IDC_MIN4FILTER, OnMin4filter)
	ON_BN_CLICKED(IDC_MAX4FILTER, OnMax4filter)
	ON_BN_CLICKED(IDC_MEDIAN, OnMedian)
	ON_BN_CLICKED(IDC_SHARP, OnSharp)
	ON_BN_CLICKED(IDC_SOBEL, OnSobel)
	ON_BN_CLICKED(IDC_ROBERTS, OnRoberts)
	ON_BN_CLICKED(IDC_FDEFFERENTIAL, OnFdefferential)
	ON_BN_CLICKED(IDC_SDEFFERENTIAL, OnSdefferential)
	ON_BN_CLICKED(IDC_ZEROCROSS, OnZerocross)
	ON_BN_CLICKED(IDC_ANYCROSS, OnAnycross)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGrayFilterDlg bZ[W nh

BOOL CGrayFilterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	/* -------------------------------------------------------------------------------- */
	// FvxSample 
	CLicenceDlg dlg;
	CConfFileDlg fdlg;

	// CZXʂ̕\
	if (dlg.DoModal() == IDOK){

		//Ӂ
		// ߂COM̏sƂYȂłB
		CoInitialize(NULL);
		CWnd *pwnd ;
		IUnknown *p_unknown;
		long err_no = 0;

		// _CAOɓ\tĂFvxDisplayEx̃CX^X擾AX}[g|C^Ɋt܂B
		pwnd = GetDlgItem(IDC_FVXDISPLAYEX1);		// FvxDisplayEx̃nh擾
		p_unknown = pwnd->GetControlUnknown();		// Rg[̎IUnknownC^[tFCX擾
		p_unknown->QueryInterface(__uuidof(IFvxDisplayEx2Ptr),(void**)&m_FvxDisplayEx);

		// eFvxRg[̃CX^X𐶐܂B
		// w肷NXԈႦȂ悤ӂĂB
		m_FvxFileAccess.CreateInstance( __uuidof( FvxFileAccess ) ); 
		m_FvxImage1.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxImage2.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxVideo.CreateInstance( __uuidof( FvxVideo ) ); 
		m_FvxROI.CreateInstance( __uuidof( FvxROI ) ); 
		m_FvxGrayFilter.CreateInstance( __uuidof( FvxGrayFilter ) ); 
		m_ExeRegion.CreateInstance( __uuidof( FvRectangle ) ); 
		
		// fBXvC̏
		m_FvxDisplayEx->CreateDisplay(1,0);
		// J荞ݗL
		GetDlgItem(IDC_GRAB)->EnableWindow(FALSE);
		// rfIfoCX̏ԂL
		m_blnVideoOpened = false;

		// ͈͂̏lݒ(摜̑Sʂɐݒj
		m_ExeRegion->Putxs( -1 );
		m_ExeRegion->Putxe( -1 );
		m_ExeRegion->Putys( -1 );
		m_ExeRegion->Putye( -1 );
    
		// ͈͂Kp
		m_FvxGrayFilter->SetInspectArea( m_ExeRegion );
		m_FvxDisplayEx->ClearOverlay( -1 );
		m_FvxDisplayEx->PutPenColor( RGB(0, 0, 255) );
		m_FvxDisplayEx->DrawData( 0, m_ExeRegion );

		// rfIݒt@C̑I
		fdlg.DoModal();

		if ( fdlg.m_check == FALSE ) {
			
		    // rfIݒt@CR|[lgɐݒ
 			m_FvxVideo->PutVideoConfFile( _bstr_t( fdlg.m_conffile ) );

			// rfIfoCXI[v
			try {

				m_FvxVideo->OpenDevice();

			} catch( _com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfIfoCX̃I[vɎs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
			}

			// VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
			// ̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
			// {vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
			// g̃Lv`{[hɍ킹ĕύXĂB
			::Sleep(350);

            // GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
            // 炩ChangeImageSize\bhɂImagẽTCYύXĂ
            // i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
			m_FvxVideo->ChangeImageSize(m_FvxImage1);

			try	{

				// 捞
				m_FvxVideo->GrabSync(m_FvxImage1);

			} catch(_com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfI̎捞Ɏs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B

			}

			// J荞ݗL
			GetDlgItem(IDC_GRAB)->EnableWindow(TRUE);
			// rfIfoCX̏ԂL
			m_blnVideoOpened = true;

		}

		// 摜̕\
		m_FvxDisplayEx->DrawImage(m_FvxImage1);

	}else{

		// ӂĂ炦Ȃ瑦I
		EndDialog( IDCANCEL );
	}

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CGrayFilterDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CGrayFilterDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CGrayFilterDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CGrayFilterDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	if (IsIconic() == 0 ) {

		if ( m_FvxDisplayEx != NULL ){

			CWnd *pwnd;
			CRect rect;

			pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
			pwnd->GetWindowRect( rect );

			// XN[WNCAgWɕϊ
			ScreenToClient( rect );

			// FvxDisplayEx̃TCYύX
			pwnd->MoveWindow( rect.left , rect.top, cx - (rect.left + 20) , cy - (rect.top + 20) , TRUE );

		}
	}
}

void CGrayFilterDlg::OnDestroy() 
{
	CDialog::OnDestroy();

    // rfIfoCXI[vĂꍇ̓N[Y܂
	if ( m_blnVideoOpened == true ) {
		m_FvxVideo->CloseDevice();	
	}
	
}

// ͈͂̐ݒ
void CGrayFilterDlg::OnExeregion() 
{

    m_FvxROI->SetRectangle( m_ExeRegion );
    
    // FvxROIgď͈͑I_CAOo܂
    long lngOK = 0;
	m_FvxROI->PutUsePoint( FALSE );
    m_FvxROI->MakeROIDialog( m_FvxImage1, &lngOK );
    
    if (( lngOK == 1 ) && ( m_FvxROI->GetCheckRectangle() == 1 )) {
        
		m_FvxROI->GetRectangle( m_ExeRegion );
        
        // n_ƏI_tɂȂĂȂ`FbN܂
        // FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
        // tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ
        double dblTemp = 0;
		if ( m_ExeRegion->Getxe() < m_ExeRegion->Getxs() ) {
            dblTemp = m_ExeRegion->Getxs();
            m_ExeRegion->Putxs( m_ExeRegion->Getxe() );
            m_ExeRegion->Putxe( dblTemp );
		}
		if ( m_ExeRegion->Getye() < m_ExeRegion->Getys() ) {
            dblTemp = m_ExeRegion->Getys();
            m_ExeRegion->Putys( m_ExeRegion->Getye() );
            m_ExeRegion->Putye( dblTemp );
		}
	}
		
    // ͈͂Kp
    m_FvxGrayFilter->SetInspectArea( m_ExeRegion );
    m_FvxDisplayEx->ClearOverlay( -1 );
    m_FvxDisplayEx->PutPenColor(RGB(0, 0, 255));
    m_FvxDisplayEx->DrawData( 0, m_ExeRegion );
	
}

void CGrayFilterDlg::OnGrab() 
{
	// 摜t@Cǂݍ݂ɂāA摜TCY
    // ύXĂ\邽߁AChangeImageSizes܂B
    // 摜TCYύX\ꍇ́AɈxsΖL܂B
	m_FvxVideo->ChangeImageSize(m_FvxImage1);

	try{

		m_FvxVideo->GrabSync(m_FvxImage1);

	}catch(_com_error ){
		long lngErr = 0;
		CString cStr;
		
		// 捞
    	m_FvxVideo->GetErrReport( &lngErr );
		cStr.Format("err_no = %d", lngErr );
		MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
		return;
	}

	// 荞񂾉摜ʂɕ\
	m_FvxDisplayEx->DrawImage(m_FvxImage1);
}

void CGrayFilterDlg::OnLoadimage() 
{
	// R_CAONX̐
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){
		m_FvxFileAccess->PutFilePath( _bstr_t(cFileDlg.GetPathName()) );

		try {
		
			m_FvxFileAccess->LoadBitmap( m_FvxImage1 );
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("Ǎ݂Ɏs܂Berr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}

		// 摜`FbN
		if (( m_FvxImage1->GetBitPerPixel()!=8 ) || ( m_FvxImage1->GetImageType ()!=imageGray )){

			MessageBox("8bitO[摜ł͂܂","G[", MB_ICONWARNING | MB_OK);

            m_FvxImage1->PutBitPerPixel( 8 );
            m_FvxImage1->PutImageType( imageGray );
            m_FvxImage1->PutImageWidth( 512 );
            m_FvxImage1->PutImageHeight( 480 );

		}

		m_FvxDisplayEx->DrawImage( m_FvxImage1 );
	}
	
}

void CGrayFilterDlg::OnSaveimage() 
{
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		m_FvxFileAccess->PutFilePath ( _bstr_t( cFileDlg.GetPathName() ));

		try {
		
			m_FvxFileAccess->SaveBitmap( m_FvxImage1 );
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
}

// ωtB^
void CGrayFilterDlg::OnAveraging() 
{
    // 摜̈ꕔ̏ꍇɁAȊǑ摜ۑ悤ARs[܂
    m_FvxImage1->CopyTo( m_FvxImage2 );
    
    //tB^s
    m_FvxGrayFilter->Averaging( m_FvxImage1, m_FvxImage2 );
   
    // ωɑĕʂ̏ł悤ɁÃC[WɃRs[Ă܂B
    // ÃRs[sƉ摜̗L͈͂ZbgĂ܂܂B
    m_FvxImage2->CopyTo( m_FvxImage1 );
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
   	
}

// vVAtB^
void CGrayFilterDlg::OnLaplacian() 
{
    m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->Laplacian( m_FvxImage1, m_FvxImage2 );
    m_FvxImage2->CopyTo( m_FvxImage1 );
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

// ߖTŏltB^
void CGrayFilterDlg::OnMinfilter() 
{
    m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->MinFilter( m_FvxImage1, m_FvxImage2 );
    m_FvxImage2->CopyTo( m_FvxImage1 );
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

// ߖTőltB^
void CGrayFilterDlg::OnMaxfilter() 
{
    m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->MaxFilter( m_FvxImage1, m_FvxImage2 );
    m_FvxImage2->CopyTo( m_FvxImage1 );
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

// SߖTŏltB^
void CGrayFilterDlg::OnMin4filter() 
{
    m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->Min4Filter( m_FvxImage1, m_FvxImage2, ALL_MODE );
    m_FvxImage2->CopyTo( m_FvxImage1 );
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

// SߖTőltB^
void CGrayFilterDlg::OnMax4filter() 
{
    m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->Max4Filter( m_FvxImage1, m_FvxImage2, ALL_MODE );
    m_FvxImage2->CopyTo( m_FvxImage1 );
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

// fBAtB^
void CGrayFilterDlg::OnMedian() 
{
    m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->Median( m_FvxImage1, m_FvxImage2 );
    m_FvxImage2->CopyTo( m_FvxImage1 );
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

// NstB^
void CGrayFilterDlg::OnSharp() 
{
    m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->Sharp( m_FvxImage1, m_FvxImage2 );
    m_FvxImage2->CopyTo( m_FvxImage1 );    
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

// \[xtB^
void CGrayFilterDlg::OnSobel() 
{
	m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->Sobel( m_FvxImage1, m_FvxImage2, (DIRECTION_TYPE )2 );
    m_FvxImage2->CopyTo( m_FvxImage1 );    
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

// o[ctB^
void CGrayFilterDlg::OnRoberts() 
{
	m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->Roberts( m_FvxImage1, m_FvxImage2 );
    m_FvxImage2->CopyTo( m_FvxImage1 );    
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

// ꎟ
void CGrayFilterDlg::OnFdefferential() 
{
    m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->Fdefferential( m_FvxImage1, m_FvxImage2, (DIRECTION_TYPE )2 );
    m_FvxImage2->CopyTo( m_FvxImage1 );
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

// QtB^
void CGrayFilterDlg::OnSdefferential() 
{
    m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->Sdefferential( m_FvxImage1, m_FvxImage2 );
    m_FvxImage2->CopyTo( m_FvxImage1 );
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

// [NXtB^
void CGrayFilterDlg::OnZerocross() 
{
    m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->ZeroCross( m_FvxImage1, m_FvxImage2, 8, 255 );
    m_FvxImage2->CopyTo( m_FvxImage1 );
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

// CӈʒuNbVO
void CGrayFilterDlg::OnAnycross() 
{
    m_FvxImage1->CopyTo( m_FvxImage2 );
    m_FvxGrayFilter->AnyCross( m_FvxImage1, m_FvxImage2, 8, 128, 255 );
    m_FvxImage2->CopyTo( m_FvxImage1 );
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

BOOL CGrayFilterDlg::PreTranslateMessage(MSG* pMsg) 
{
	if(pMsg->message == WM_KEYDOWN)
	{
		switch( pMsg->wParam )
		{
			case VK_RETURN:
			case VK_ESCAPE:
				return false;
		}
	}	
	return CDialog::PreTranslateMessage(pMsg);
}
